
#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include "globdata.h"
#include "templates.h"
#include "syntax.h"

void add_key(char *name,int type)   //   
{
_treeitemptr item,cur_item=firstitem;
int i;
item=new _idtreeitem;
if(firstitem==NULL) 
  firstitem=item;
  else
  while(1)
      {
       i=strcmp(cur_item->name,name);
       if(i==0) 
         {
          return;
         }
       if(i>0)
         {
          if(cur_item->left!=NULL) 
            {
             cur_item=cur_item->left;
            } 
            else 
            {
             cur_item->left=item;
             break;
            }
         }
       else
         {
          if(cur_item->right!=NULL) 
            {
             cur_item=cur_item->right;
            }
            else 
            {
             cur_item->right=item;
             break;
            }
         }
      }
strcpy(item->name,name);
item->size=strlen(name);
item->type=type;
item->left=NULL;
item->right=NULL;
}

void make_basic_id_list()   //    
{
int i;
for(i=0;i<7;i++) add_key(keys[i],ID);
for(i=0;i<32;i++) add_key(frbdkeys[i],FORBIDDEN);
}

void lerror(int line,int err)   //    
{
printf("Line %d, error %d\n",line,err);
exit(1);
}

void add_item(_idptr id1)   //  
{
char buf[200];
_treeitemptr item,cur_item=firstitem;
int i;
item=new _idtreeitem;
while(1)
{
i=strcmp(cur_item->name,id1->name);
if(i==0) 
  {
   if(cur_item->type==FORBIDDEN) lerror(id1->line,18);
   return;
  }
if(i>0)
  {
   if(cur_item->left!=NULL) 
     {
      cur_item=cur_item->left;
     } 
     else 
     {
      cur_item->left=item;
      break;
     }
  }
else
  {
   if(cur_item->right!=NULL) 
     {
      cur_item=cur_item->right;
     }
     else 
     {
      cur_item->right=item;
      break;
     }
  }
}
item->size=id1->size;
item->type=id1->type;
if(id1->type==TXT)
  {
   item->num=str_count;
   str_count++;
   for(i=0;i<(int)strlen(id1->name)-1;i++)
      if(id1->name[i]=='\\' && id1->name[i+1]=='n')
        {
         id1->name[i]='"';
         id1->name[i+1]='"';
         for(int f=strlen(id1->name)+7;f>i;f--) id1->name[f]=id1->name[f-7];
         id1->name[i+1]=',';
         id1->name[i+2]='1';
         id1->name[i+3]='3';
         id1->name[i+4]=',';
         id1->name[i+5]='1';
         id1->name[i+6]='0';
         id1->name[i+7]=',';
        }
   sprintf(buf,"text_%d\t\tdb\t%s,0\r\n",item->num,id1->name);
   strcat(asm_file,buf);
  }
strcpy(item->name,id1->name);
item->left=NULL;
item->right=NULL;
}

_id *detect(DWORD offset) //  
{
int i=1;
static _id *id1;
id1=new _id;
id1->name[0]=0;
id1->size=0;
id1->type=0;
id1->type=UNKNOWN;
id1->line=cur_line;
if(body[offset]>='0' && body[offset]<='9')
  {
   id1->name[0]=body[offset];
   id1->name[1]=0;
   offset++;
   id1->size++;
   id1->type=NUMBER;
   while(body[offset]>='0' && body[offset]<='9' && offset<readed)
        {
         id1->name[i]=body[offset];
         offset++;
         i++;
		 id1->name[i]=0;
         id1->size++;
        }
   if(body[offset]>='a' && body[offset]<='z') lerror(cur_line,1);
  }
else
if(body[offset]>='a' && body[offset]<='z')
  {
   id1->name[0]=body[offset];
   id1->name[1]=0;
   offset++;
   id1->size++;
   id1->type=ID;
   while(((body[offset]>='0' && body[offset]<='9') || (body[offset]>='a' && body[offset]<='z')) && offset<readed)
        {
         id1->name[i]=body[offset];
         offset++;
         i++;
		 id1->name[i]=0;
         id1->size++;
        }
  }
else
if(body[offset]=='"')
  {
   id1->name[0]=body[offset];
   id1->name[1]=0;
   offset++;
   id1->size++;
   id1->type=TXT;
   while(body[offset]!='"' && offset<readed)
        {
         id1->name[i]=body[offset];
         offset++;
         i++;
		 id1->name[i]=0;
         id1->size++;
        }
   if(body[offset]=='"' && offset<readed)
     { 
      id1->name[i]=body[offset];
      offset++;
      i++;
	  id1->name[i]=0;
      id1->size++;
     }
  }
else
if(body[offset]=='=' || body[offset]=='>' || body[offset]=='<' || body[offset]=='!')
  {
   id1->type=COMPARE;
   id1->name[0]=body[offset];
   id1->name[1]=0;
   offset++;
   id1->size++;
   if(body[offset]=='=')
     {
      id1->name[1]=body[offset];
      id1->name[2]=0;
      offset++;
      id1->size++;
     }
  }
else
if(body[offset]>32 && offset<readed)
  {
   id1->type=DELIMITER;
   id1->name[0]=body[offset];
   id1->name[1]=0;
   offset++;
   id1->size++;
  }
return id1;
}

void check_lexic()  //  
{
int i=0,ct,cs,nt,ns;        // cur_type,cur_symb,next_type,next_symb
while(i<iditemcount-1)
   {
    ct=iditem[i]->type;
    cs=iditem[i]->name[0];
    nt=iditem[i+1]->type;
    ns=iditem[i+1]->name[0];
    if(ct==ID)
      {
       if(nt!=ID && ns!='(' && ns!=')' && ns!='+' && ns!='-' && ns!='*' && ns!='/' && ns!=';' && ns!=',' && ns!='=' && ns!='<' && ns!='>' && ns!='{' && ns!='!')
         lerror(iditem[i]->line,2);
      }
    else
    if(ct==NUM)
      {
       if(ns!=')' && ns!='+' && ns!='-' && ns!='*' && ns!='/' && ns!=';' && ns!=',')
         lerror(iditem[i]->line,3);
      }
    else
    if(cs=='(')
      {
       if(nt!=ID && nt!=NUM && nt!=TXT && ns!=')' && ns!='(')
         lerror(iditem[i]->line,4);
      }
    else
    if(cs==')')
      {
       if(nt!=ID && ns!=')' && ns!=';' && ns!='+' && ns!='-' && ns!='*' && ns!='/' && ns!='{' && ns!=',')
         lerror(iditem[i]->line,5);
      }
    else
    if(cs=='{')
      {
       if(nt!=ID && ns!=';' && ns!='{' && ns!='}')
         lerror(iditem[i]->line,6);
      }
    else
    if(cs=='}')
      {
       if(nt!=ID && ns!=';' && nt!=EOF && ns!='}')
         lerror(iditem[i]->line,7);
      }
    else
    if(cs=='+')
      {
       if(nt!=ID && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,8);
      }
    else
    if(cs=='-')
      {
       if(nt!=ID && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,9);
      }
    else
    if(cs=='*')
      {
       if(nt!=ID && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,10);
      }
    else
    if(cs=='/')
      {
       if(nt!=ID && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,11);
      }
    else
    if(cs=='=')
      {
       if(nt!=ID && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,12);
      }
    else
    if(cs=='>')
      {
       if(nt!=ID && nt!=NUM && ns!='(' && ns!='=')
         lerror(iditem[i]->line,13);
      }
    else
    if(cs=='<')
      {
       if(nt!=ID && nt!=NUM && ns!='(' && ns!='=')
         lerror(iditem[i]->line,14);
      }
    else
    if(cs==';')
      {
       if(nt!=ID && ns!='}' && ns!=';' && ns!='{')
         lerror(iditem[i]->line,15);
      }
    else
    if(ct==TXT)
      {
       if(ns!=',' && ns!=')')
         lerror(iditem[i]->line,16);
      }
    else
    if(cs==',')
      {
       if(nt!=ID && nt!=TXT && nt!=NUM && ns!='(')
         lerror(iditem[i]->line,17);
      }
    i++;
   }
}

void scanner() //  
{
_id *id1;
while(i<(int)readed)
    {
     if((body[i]==13 && body[i+1]==10) || (body[i]==10 && body[i+1]==13))
       {
        cur_line+=1;
        i+=2;
       }
     else
     if(body[i]==13 || body[i]==10)
       {
        cur_line++;
        i++;
       }
     else
     if(body[i]=='/' && body[i+1]=='*')
       {
        i+=2;
        while((body[i]!='*' || body[i+1]!='/') && i<(int)readed) i++;
        if(body[i+1]=='/' && body[i]=='*') i+=2;
       }
     else
       {
        id1=detect(i);
        if(id1->size==0)
          {
           i++;
           delete id1;
          }
          else 
          {
           i+=id1->size;
           iditem[iditemcount]=id1;
           if(id1->type==ID || id1->type==NUMBER || id1->type==TXT) add_item(id1);
           iditemcount++;
          }
       }
    }
id1=new _id;
id1->type=EOF;
id1->name[0]=0;
iditem[iditemcount]=id1;
iditemcount++;
}

void print_tree(_treeitemptr cur_item)
{
for(int i=0;i<tab_index;i++) printf("\t");
printf("%s %d\n",cur_item->name,cur_item->type);
tab_index++;
if(cur_item->left!=NULL) print_tree(cur_item->left);
if(cur_item->right!=NULL) print_tree(cur_item->right);
tab_index--;
}

void main(int argc, char *argv[], char *envp[])     //  
{
char asm_filename[500],filename[500];
char *tmp;
printf("\nMini C to Assembler Translator\nCopyright (c) Yuri Kudrin, 2000.\n\n");
if(argc!=2) {printf("Command line: C2ASM filename.cpp\n");return;}
strcpy(filename,argv[1]);
strlwr(filename);
strcpy(asm_filename,filename);
tmp=strstr(asm_filename,".cpp");
if(tmp==NULL) {printf("Error in the file name\n");return;}
strcpy(tmp,".asm");
filehandle=CreateFile(filename,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL);
if(filehandle==INVALID_HANDLE_VALUE) {printf("File is not found");return;}
ReadFile(filehandle,&body,10000,&readed,NULL);
CloseHandle(filehandle);
if(readed<8) {printf("The file is too short");return;}
i=0;
//printf("File length is %d bytes\n\n",readed);
insert_src1();
make_basic_id_list();
scanner();
check_lexic();
_prog_();
insert_src3();
//printf("Tree of identifiers\n-------------------\n");
//print_tree(firstitem);
//for(i=0;i<iditemcount;i++) printf("%s\n",iditem[i]->name);
filehandle=CreateFile(asm_filename,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
WriteFile(filehandle,&asm_file,strlen(asm_file),&written,NULL);
CloseHandle(filehandle);
printf("%s file was created successfully.\n",asm_filename);
}
